#include "Simulator.h"
#include <map>
#include <string.h>
#include <vector>
#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <numeric>
#include <sstream>
#include <math.h>
#include <iostream>
//#include "SerialCommunication.h"
#include "SimpleSerial.h"


using namespace std;
//default constructor

CSimulator::CSimulator() :
serial("/dev/ttyUSB1", 9600) {
//serial("/dev/ttyUSB1", 19200) { //stari parametri

}

CSimulator::~CSimulator() {
}

bool CSimulator::OnNewMail(MOOSMSG_LIST &NewMail) {
      MOOSMSG_LIST::iterator p;
    for (p = NewMail.begin(); p != NewMail.end(); p++) {
        CMOOSMsg & rMsg = *p;
        if (MOOSStrCmp(rMsg.GetKey(), "LeftThruster")) {
            serial.writeString(rMsg.GetString());
        }
        else if (MOOSStrCmp(rMsg.GetKey(), "RightThruster")) {
            serial.writeString(rMsg.GetString());
        }
    }
    return true;
}

bool CSimulator::OnConnectToServer() {
    m_Comms.Register("LeftThruster", 0);
    m_Comms.Register("RightThruster", 0);
    return true;
}

bool CSimulator::Iterate() {
 
    return true;
}

bool CSimulator::OnStartUp() {
    m_Comms.Register("LeftThruster", 0);
    m_Comms.Register("RightThruster", 0);
    return true;
}
