#include "Simulator.h"
#include <map>
#include <string.h>
#include <vector>
#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <numeric>
#include <sstream>
#include <math.h>
#include <iostream>
//#include "SerialCommunication.h"
#include "SimpleSerial.h"


using namespace std;
//default constructor


CSimulator::CSimulator():
serial("/dev/ttyUSB0", 19200){

}

//default (virtual) destructor

CSimulator::~CSimulator() {
}

/** 
Called by base class whenever new mail has arrived.
Place your code for handling mail (notifications that something
has changed in the MOOSDB in this function

Parameters:
    NewMail :  std::list<CMOOSMsg> reference

Return values:
    return true if everything went OK
    return false if there was problem
 **/
bool CSimulator::OnNewMail(MOOSMSG_LIST &NewMail) {


}

/**
called by the base class when the application has made contact with
the MOOSDB and a channel has been opened. Place code to specify what
notifications you want to receive here.
 **/
bool CSimulator::OnConnectToServer() {
    
    
    return true;
}

/** Called by the base class periodically. This is where you place code
which does the work of the application **/
bool CSimulator::Iterate() {
    size_t compassStart;
    size_t compassEnd;
    


    string usbData = serial.readString();

    if (usbData.substr(0,2)=="$C"){
	compassStart = usbData.find("$C") + 2;
	compassEnd = usbData.find("P");
	compassData=usbData.substr(compassStart, compassEnd - compassStart);
    }
    m_Comms.Notify("CompassData",compassData,0);
    cout << usbData << '\n';
    cout<<"poslano"<<std::endl;
    return true;
}

/** called by the base class before the first ::Iterate is called. Place
startup code here - especially code which reads configuration data from the 
mission file **/
bool CSimulator::OnStartUp() {
    return true;
}
