#include "Simulator.h"
#include <map>
#include <string.h>
#include <vector>
#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <numeric>
#include <sstream>
#include <math.h>
#include <iostream>
#include "SimpleSerial.h"
using namespace std;

CSimulator::CSimulator() :
serial("/dev/ttyUSB0", 19200) {
}

CSimulator::~CSimulator() {
}

bool CSimulator::OnNewMail(MOOSMSG_LIST &NewMail) {
}

bool CSimulator::OnConnectToServer() {
    return true;
}

bool CSimulator::Iterate() {
    size_t longitudeStart;
    size_t longitudeEnd;
    size_t latitudeStart;
    size_t latitudeEnd;
    size_t pom;
    string temp;

    string usbData = serial.readString();
    if (usbData.substr(0, 6) == "$GPGGA") {
        pom = usbData.find(",");
        temp = usbData.substr(pom + 1); 
        latitudeStart = temp.find(",") + 1;
        temp = temp.substr(latitudeStart);
        latitudeEnd = temp.find(",");
        latitude = temp.substr(0, latitudeEnd);
        temp = temp.substr(latitudeEnd + 1);
        indic_NS = temp.substr(0, 1);
        temp = temp.substr(2);
        longitudeEnd = temp.find(",");
        longitude = temp.substr(0, longitudeEnd);
        temp = temp.substr(longitudeEnd + 1);
        indic_EW = temp.substr(0, 1);
    }
    m_Comms.Notify("Latitude", latitude, 0);
    m_Comms.Notify("Longitude", longitude, 0);
    m_Comms.Notify("Indic_EW", indic_EW, 0);
    m_Comms.Notify("Indic_NS", indic_NS, 0);
    cout << latitude << '\n';
    cout << longitude << '\n';
    cout << indic_EW << '\n';
    cout << indic_NS << '\n';  
    return true;
}

bool CSimulator::OnStartUp() {

    return true;
}
